import java.util.*;
/**
@author  hco
@version 1.4

*/
public class Player extends Thread
{
    public boolean playingLeftToRight=false;
    boolean isGoalie=false;
    boolean isDefense=false;
    int playerNr;
    int homeposx;
    int homeposy;

    private String serverAddress="localhost";
    private int portNo=6000;

    // ab hier: Variablen fr die Strategie
    
    public CommunicationChannel Netz;
    public Actor BefehlsEmpfaenger;
    public Parser Augen;
    public Strategy Strategie;
    public WorldModel WeltBild;

    Player(int homeposx_uebergabe, int homeposy_uebergabe, boolean isGoalie, boolean isDefense)
	{
	    homeposx=homeposx_uebergabe;
	    homeposy=homeposy_uebergabe;
	    this.isGoalie=isGoalie;
	    this.isDefense=isDefense;
	    
	}

Player(int homeposx_uebergabe, int homeposy_uebergabe, String serverAddress, int portNo, boolean isGoalie, boolean isDefense)
	{
	    homeposx=homeposx_uebergabe;
	    homeposy=homeposy_uebergabe;
	    this.serverAddress=serverAddress;
	    this.portNo=portNo;
	    this.isGoalie=isGoalie;
	    this.isDefense=isDefense;
	}


    /**
    das ist wieder die run methode
   */
    
    public void run() {
	/**
	1. ComChannel aufmachen
	*/
	Netz=new CommunicationChannel(serverAddress, portNo);
	String msg,temp;
	StringTokenizer mini_tokenizer;
	
	/**
	 2. Actor aufmachen, da stehen die Sachen drin, die der Spieler machen kann
	 */
	BefehlsEmpfaenger=new Actor(Netz);
	
	if (isGoalie)
	    {        
		BefehlsEmpfaenger.initGoalie("ManU");
	    } else {
		BefehlsEmpfaenger.init("ManU");
	    }

        msg=Netz.receive();
        while (!msg.startsWith("(init"))
        {
            msg=Netz.receive();
        }

        // Der 1. Token enthaelt die Daten
        mini_tokenizer = new StringTokenizer(msg);
        //ignore: erster Token ist "(init"
        temp=mini_tokenizer.nextToken();
        //Eigene Seite
        temp=mini_tokenizer.nextToken();
        if (temp.equals("l"))
        {
            playingLeftToRight=true;
        } else {
            playingLeftToRight=false;
        }
        //Spielernr.
        playerNr=Integer.parseInt(mini_tokenizer.nextToken());
        //before_kick_off)
        temp=mini_tokenizer.nextToken();

	/**
	 3. WeltBild eroeffnen
	*/

	if (playingLeftToRight)
        {
            WeltBild=new LeftModel();
        } else {
            WeltBild=new RightModel();
        }

	/**
	 4. Parser aufmachen, zustndig fr sense_body messages
	*/
	Augen=new Parser(this);
	// Augen=new Parser(Netz);
	
	/**
	 5. Strategie ffnen, regelt die Aktionen des Spielers
	*/
	
	//Strategie = new Strategy(this);
	if (isGoalie)
	    {
		Strategie = new StrategyGoalie(this);
	    } else {
		if (isDefense)
		    {
			Strategie = new StrategyDefense(this);
		    } else {
			Strategie = new StrategyPlayer(this);
        System.out.println("ein neuer player wurde ertellt!");
		    }
	    }
	
	/**
	  6. Parser von der Strategie informieren
	*/
	    //das koennte man umgehen, aber so ist das ok.
	    Augen.addStrategy(Strategie);

	/**
	  6. Actor mit Parser versehen
	*/
	    this.BefehlsEmpfaenger.add_parser(this.Augen);

	Strategie.start();

	Augen.start();







    }



}
