// RightModel.java
// Spielrichtung rechts => links

import java.util.*;

/**
@author Deike Priemuth
@version 1.10
RightModel.java
Spielrichtung rechts => links
 */

class RightModel extends WorldModel {
    
    /** Berechnung der absoluten X und Y Koordinaten des aktuellen Spielers 
     */
    
    protected void calculateMe() {
	
	double minDist = 200; 
	int minIndex = -1;
	// Koordinaten der naehesten Flagge oder Goal
	double closestX;
	double  closestY; 
	size = statList.size();	
	
	/** Berechnung des absoluten Winkels anhand einer Linie
	 */
	//System.out.println("Linie: ("+actualObject.name+")");	

	// Doppeltes if ist billiger als switch
	if (actualObject.name.charAt(2) < 110) { // == b oder l
	    if (actualObject.name.charAt(2) == 98) { // == b
		// Berechnung fuer bottom
		if (actualObject.dir > 0) {
		    absW = 0 - actualObject.dir;
		} else {
		    absW = -180 - actualObject.dir;
		}
	    } else { // == l
		// Berechnung fuer left
		if (actualObject.dir > 0) {
		    absW = 90 - actualObject.dir;
		} else {
		    absW = -90 - actualObject.dir;
		}
	    }
	} else {
	    if (actualObject.name.charAt(2) == 114) { // == r
		// Berechnung fuer right
		if (actualObject.dir > 0) {
		    absW = -90 - actualObject.dir;
		} else {
		    absW = 90 - actualObject.dir;
		}
	    } else {
		// Berechnung fuer top
		if (actualObject.dir > 0) {
		    absW = 180 - actualObject.dir;
		} else {
		    absW = 0 - actualObject.dir;
		}
	    }
	}	
	
	// durchsuchen der statList nach der naehesten Flagge, bzw. Goal
	// alle Elemente ausser letztem, da Linie
	for (int i = 0; i < size - 1; i++) {
	    tempObject = (WorldModelElement)statList.get(i);
	    if (tempObject.dist < minDist) {
		// Anonyme Flaggen (Grossbuchstaben) ausfiltern
		if (tempObject.name.charAt(0) > 96) {
		    minDist = tempObject.dist;
		    minIndex = i;
		}
	    }
	}
	
	// Bestimmen der gefundenen Flagge/Goal
	// zuweisen ihrer X und Y Koordinate
	
	checkObject = (WorldModelElement)statList.get(minIndex);
	String checkname = checkObject.name;

	//System.out.println("naehste Flagge: ("+checkname+")");


	if (checkname.charAt(0) == 103) { // goal [rl]
	    closestX = 52.5;
	    closestY = 0;
	    if (checkname.charAt(2) == 114) { // g r 
		closestX *= -1;
	    }
	} // goals
	
	else { // flags
	    if (checkname.charAt(2) < 106) { // flag [bcg]...
		if (checkname.charAt(2) == 99) { // flag c...
		    closestX = 0;
		    if (checkname.length() < 4) { // flag c
			closestY = 0;
		    } // f c
		    else if (checkname.charAt(4) == 98) { // flag c b
			closestY = -34;
		    } // f c b 
		    else { // flag c t
			closestY = 34;
		    } // f c t
		} // f c...
		else if (checkname.charAt(2) == 103) { // flag g...
		    if (checkname.charAt(4) == 108) { // flag g l []
			closestX = 52.5;
		    } // f g l []
		    else { // flag g r []
			closestX = -52.5;
		    } // f g r []
		    if (checkname.charAt(6) == 98) { // flag g [] b
			closestY = -7.01;
		    } // f g [] b
		    else { // flag g [] t
			closestY = 7.01;
		    } // f g [] t 
		} // f g...
		else { // flag b...
		    closestY = -39;
		    if (checkname.charAt(4) == 48) { // flag b 0
			closestX = 0;
		    } // f b 0
		    else {
			closestX = Integer.parseInt(checkname.substring(6, 8));
			if (checkname.charAt(4) == 114) { // flag b r...
			    closestX *= -1;
			}
		    } // f b [lr] []
		} // f b
	    } // f [bcg]
	    else {
		if (checkname.charAt(2) < 113) { // == l oder p
		    if (checkname.charAt(2) == 112) { // flag p...
			closestX = 36;
			// f p l []
			if (checkname.charAt(4) == 114) { // flag p r []
			    closestX *= -1;
			} // f p r []
			if (checkname.charAt(6) == 99) { // flag p [] c
			    closestY = 0;
			} // f p [] c
			else { // f p [] [bt]
			    if (checkname.charAt(6) == 98) { // flag p [] b
				closestY = -20.175;
			    } // f p [] b
			    else { // f p [] t
				closestY = 20.175;
			    } // f p [] t
			}
		    } // f p...
		    else { // flag l...
			if (checkname.length() < 6) { // flag l [0tb]
			    if (checkname.charAt(4) == 48) { // flag l 0
				closestX = 57.5;
				closestY = 0;
			    } // f r 0		    
			    else { // flag l [tb]
				closestX = 52.5;
				closestY = -34;
				if (checkname.charAt(4) == 116) { // flag l t
				    closestY *= -1;
				} // f l t
			    } // f l [tb]
			} // f l [0tb]
			else { // f l [bt]...
			    closestX = 57.5;
			    closestY = Integer.parseInt(checkname.substring(6, 8));
			    if (checkname.charAt(4) == 98) { // flag l b...
				closestY *= -1;
			    } // f l b...
			} // f l [bt]...
		    } // f l...
		} // f [lp]
		else { // == r oder t
		    if (checkname.charAt(2) == 116) { // flag t...
			closestY = 39;
			if (checkname.charAt(4) == 48) { // flag t 0
			    closestX = 0;
			} // f t 0
			else {
			    closestX = Integer.parseInt(checkname.substring(6, 8));
			    if (checkname.charAt(4) == 114) { // flag t r...
				closestX *= -1;
			    }
			} // f t [lr] []
		    } // f t
		    else { // flag r...
			if (checkname.length() < 6) { // flag r [0tb]
			    if (checkname.charAt(4) == 48) { // flag r 0
				closestX = -57.5;
				closestY = 0;
			    } // f r 0		    
			    else { // flag r [tb]
				closestX = -52.5;
				closestY = -34;
				if (checkname.charAt(4) == 116) { // flag r t
				    closestY *= -1;
				} // f r t
			    } // f r [tb]
			} // f r [0tb]
			else { // f r [bt]...
			    closestX = -57.5;
			    closestY = Integer.parseInt(checkname.substring(6, 8));
			    if (checkname.charAt(4) == 98) { // flag r b...
				closestY *= -1;
			    } // f l b...
			} // f l [bt]...
		    } // f r
		} // f [rt]
	    } // f [lprt]
	} // flags
	
	// Ausrechnen meiner X und Y Koordinaten anhand der gefunden
	// Flaggenkoordinaten und des berechneten Winkels

	//System.out.println("closestX: "+ closestX +" closestY: "+ closestY);

	zwischenW = absW + checkObject.dir;
	myX = closestX - (checkObject.dist * Math.cos(Math.toRadians(zwischenW)));
	myY = closestY - (checkObject.dist * Math.sin(Math.toRadians(zwischenW)));
	
	System.out.println("RM: myX: "+myX+" myY: "+myY+" absW: "+absW);
	
    }
}



