//doc fertig

import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;

/**  visualisation.java      Stand: 23.06.02
 *   - Visualisierung des Weltbildes aus Sicht eines einzelnen Spielers
 *   Hierbei handelt es sich schwerpunktmig um die Erzeugung des GUI (unter Zuhilfenahme der Klasse
 *   visualisation_field.java) sowie deren Threads(permanente WorldModelElement-Abfrage)
 *
 *    @author Esther Krug, Marcus Mandel
 *    @version $Id: Visualisation.java,v 1.4 2002/07/14 09:56:43 hco Exp $
 */

class Visualisation extends JComponent
{
  // variablen fr grafische elemente
  private static JTextField geklickt;
  private static JButton anzeigen, stoppen, schliessen;
  private JPanel alles, oben, unten, mitte;
  private static JComboBox auswahl;

  // um den ausgewhlten Spieler von String nach int zu konvertieren
  private Integer ausgewaehlter_spieler_obj;
  private int ausgewaehlter_spieler;
  public String ausgewaehlter_spieler_str;

  private Visualisation_field_draw hintergrund_spielfeld;
  private Player[] spielerarray;
  private boolean anzeige_lauft;// braucht man, damit nicht der Thread x mal gestartet wird


/**
Das ist der Konstruktor der die Bunten Blinkedings macht
*/
  public Visualisation(Player[] alle_spieler)//  hier beginnt der Konstruktor
  {
    spielerarray = alle_spieler;


    // den Frame initalisieren:
    this.add(alles = new JPanel());
    alles.setSize(620, 525);
    alles.setLayout(new BorderLayout());

    // die dinger in dem Frame machen
    hintergrund_spielfeld = new Visualisation_field_draw(spielerarray);
    hintergrund_spielfeld.init(); // dieses JPanel ist runnable und
    //sorgt spter fr die kontinuierliche Aktualisierung der Punkte auf dem Feld

    alles.add(mitte = hintergrund_spielfeld, BorderLayout.CENTER);


    JPanel unten = new JPanel();
    alles.add(unten, BorderLayout.SOUTH);
      unten.setLayout(new FlowLayout(2, 25, 5));
      // die Buttons, das Textfield und die ComboBox erstellen und einfgen:
      unten.setBackground(Color.blue);
      unten.add("400,5", schliessen = new JButton("schlieen"));




    JPanel oben = new JPanel();
    oben.setLayout(new FlowLayout());
    alles.add(oben, BorderLayout.NORTH);
      oben.setBackground(Color.blue);
      oben.add(geklickt = new JTextField(20));
      oben.add(auswahl = new JComboBox());
      oben.add(anzeigen = new JButton("anzeigen"));
      oben.add(stoppen = new JButton("STOP!"));

    geklickt.setText("Whlen Sie einen anzuzeigenden Spieler");
    geklickt.setEditable(false);


     //Fllung der ComboBox
    auswahl.addItem("Spieler 01 (Torwart)");
    auswahl.addItem("Spieler 02 (Defense)");
    auswahl.addItem("Spieler 03 (Defense)");
    auswahl.addItem("Spieler 04 (Defense)");
    auswahl.addItem("Spieler 05 (Defense)");
    auswahl.addItem("Spieler 06 (Defense)");
    auswahl.addItem("Spieler 07 (Defense)");
    auswahl.addItem("Spieler 08 (Offense)");
    auswahl.addItem("Spieler 09 (Offense)");
    auswahl.addItem("Spieler 10 (Offense)");
    auswahl.addItem("Spieler 11 (Offense)");

  }// konstruktor ende

/**
Startet die Visualisierung
*/
  public void startVis()
  {
    System.out.println("start visu");
    //Instanziierung des Frames
    final JFrame f = new JFrame ("Visualisierung");


    f.getContentPane().add(this);
    f.setResizable(false);
    f.setSize(650, 570);
    f.setVisible(true); // wichtig, weil default is scheinbar false!


    //WindowListener zum Schlieen, wenn man aufs Kreuzchen klickt
    f.addWindowListener(new WindowAdapter()
    {
      public void windowClosing(WindowEvent event)
      {

        // diese zeile rauskommentieren, wenn's richtig verwendet wird!
        System.exit(0); // ACHTUNG ! macht alles zu!
        //stattdessen ein getWindow().dipose() oder so
      }
    });


    //Methode zum Anzeigen des in der ComboBox gewhlten Spielers
    anzeigen.addActionListener(new ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {

        if (!anzeige_lauft)
        {
          hintergrund_spielfeld.start();
          anzeige_lauft = true;
        }
          // das extrahiert aus dem String im Textfeld die Spielernummer, nachdem der String ins
          // Textfeld gesetzt wurde.

          ausgewaehlter_spieler_str = new String(""+auswahl.getSelectedItem()+"");
          geklickt.setText(ausgewaehlter_spieler_str + " gewhlt");

          ausgewaehlter_spieler_str = ausgewaehlter_spieler_str.substring(8,10);
          ausgewaehlter_spieler_obj = new Integer(ausgewaehlter_spieler_str);
          ausgewaehlter_spieler = ausgewaehlter_spieler_obj.intValue();

        hintergrund_spielfeld.set_ausgewaehlter_spieler(ausgewaehlter_spieler);
        f.setTitle("Visualisierung - Das Weltbild aus Sicht von Spieler " + ausgewaehlter_spieler_str);

      }
    });


    //unterbricht die Zeichenschleife "Screenshotmig"
    stoppen.addActionListener(new ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {

        // das beendet den Thread, der was malt
        hintergrund_spielfeld.stop();
        anzeige_lauft = false;
      }
    });


    //macht die Visu zu, aber nicht das ganze Programm
    schliessen.addActionListener(new ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        f.dispose();
        System.out.println("fenster zu, programm noch da");

      }
    });



  }//startVis ende



//Klassen-Ende
}








