// war CompleteModel.java ist WorldModel.java


import java.util.*;

/**
@author Deike Priemuth
@version 1.9
WorldModel.java
abstrakte Klasse
*/

abstract class WorldModel {


    // aktuelle Liste;
    protected LinkedList t0 = new LinkedList();
    // aeltere
    protected LinkedList t1 = new LinkedList();
    //aelteste
    protected LinkedList t2 = new LinkedList();
    
    protected LinkedList statList;
    protected LinkedList dynList;
    protected int size;
    protected int time;
    protected WorldModelElement actualObject;
    protected WorldModelElement checkObject;
    protected WorldModelElement tempObject;
    protected double absW;
    protected double zwischenW;
    protected double myX; 
    protected double myY;
   

   /** Methode zum uebernehmen der beiden Listen vom Parser
    @param time  =  zeitstempel
    @param LinkedList stat  =  enthdlt alle festen objekte  (flags,linien,tore)
    @param LinkedList dyn  =  enthdlt alle beweglichen objekte (Spieler,Ball)
    */

    public void giveObjectList(int time, LinkedList stat, LinkedList dyn)
    {
	this.statList = stat;
	this.dynList = dyn;
	this.time = time;

	size = statList.size();

       	// Abfrage ob mindestens 2 Elemente in der statList
	if ( size > 1 ) {
	    actualObject = (WorldModelElement)statList.getLast();
	    
	    // Abfrage ob letztes Element eine Linie
	    if (actualObject.name.charAt(0) == 108) { // == l 
		checkObject = (WorldModelElement)statList.get(size-2);
		
		// Abfrage ob vorletztes Element eine Linie
		if (checkObject.name.charAt(0) == 108) { // == l 
		    checkObject = (WorldModelElement)statList.remove(size-2);
		    calculateMe();
                    calculatePlayer();
		    einfuegen(myX, myY, absW, time); 
		}
		else {
		    calculateMe();	
		    calculatePlayer();
		    einfuegen(myX, myY, absW, time);
		}
	    }
	    else {
		myX=Double.NaN;
		myY=Double.NaN;
		absW=Double.NaN;
		einfuegen(myX, myY, absW, time); 
	    }
	} 
	
	else {
	    myX=Double.NaN;
	    myY=Double.NaN;
	    absW=Double.NaN;
	    einfuegen(myX, myY, absW, time); 
	}

	//System.out.println("WM: myX: "+myX+" myY: "+myY);
	
    }
    
    /**Methoden, dass Strategie und Visualisierung draufzugreifen koennen
     */
    public LinkedList getT0()
    {
	return t0;
    }
    public LinkedList getT1()
    {
	return t1;
    }
    public LinkedList getT2()
    {
	return t2;
    }
    
    // Berechnung der anderen Spieler mittels meiner X und Y Koordinaten 
    // und des absoluten Winkels
    protected void calculatePlayer()
    {  
	// dynList vor meinem Einfuegen
	int dynsize = dynList.size();
      	for (int i = 0; i < dynsize; i++) {
	    tempObject = (WorldModelElement)dynList.get(i);
	    zwischenW = absW + tempObject.dir;
	    tempObject.x = myX + (tempObject.dist * Math.cos(Math.toRadians(zwischenW)));
	    tempObject.y = myY + (tempObject.dist * Math.sin(Math.toRadians(zwischenW))); 
	}	
	
    }

    /** Methode zum einfuegen meiner Position an erster Stelle in dynList   
     */
    protected void einfuegen( double x, double y, double w, double t)
    {
	actualObject = new WorldModelElement();
	actualObject.name = "ich";
  	actualObject.isFriend = 0;
	actualObject.x = x;
  	actualObject.y = y;
	actualObject.dir = w;
  	actualObject.dist = t;
	
	dynList.addFirst(actualObject);
	
	t2 = t1;
	t1 = t0;
	t0 = dynList;

    }

    /** leere Methode die vom Left- oder RightModel mit Leben gefuellt wird
     */
    protected void calculateMe()
    {
    }

}










